import { Bud } from '@roots/bud-framework';
/**
 * Execute a function after compiler has finished
 */
export const after = function (fn, errorHandler) {
    this.hooks.action(`compiler.done`, async (bud) => {
        await fn(bud).catch(error => {
            if (errorHandler)
                return errorHandler(error);
            bud.catch(error);
        });
    });
    return this;
};
